; **************************************************************************
;
;        SC/MP Dice by A.M. Scott, from Computing Today April 1980
;
;       Run from 0F20. Press TERM to generate dice roll, and GO to roll
;       again.
;
;       This is a bit flickery, because of the way the keyboard is
;       scanned primarily.
;
;       A later fix to the emulator emulating the LED persistence better
;       would be worthwhile.
;
; **************************************************************************

Die     .equ    0F1Fh+1                 ; work space

SegTab  .equ    010Bh                   ; hex to 7 segment conversion in SCIOS
                                                      
        .org    0F20h

        ldi     SegTab >> 8             ; P1 := Hex to 7 Segment Table
        xpah    1
        ldi     SegTab & 255
        xpal    1
        ldi     0Dh                     ; P2 := Display at 0D00
        xpah    2
        ldi     00h
        xpal    2
Repeat: ldi     1                       ; Start
        st      Die                     ; Store Die 1
        xae                             ; Store Die 2
        ild     7(2)                    ; Is Term Pressed
        jnz     Show                    ; if so,show the resut

Test:   ld      Die                     ; Die1 = 6 ?
        xri     6
        jnz     Incr                    ; if not, increment
        lde                             ; Die2 = 6 ?
        xri     6
        jz      Repeat                  ; if so, reset both dice to 1
        ldi     1                       ; Die 1 = 1
        st      Die
        ade                             ; and Increment Die 2
        xae
        jmp     Press
Incr:   ild     Die                     ; Increment Die 1
Press:  ild     7(2)                    ; Term pressed ?
        jz      Test                    ; if not, try again

Show:   ld      Die                     ; get Dice 1 pattern
        st      SelfMod+1+1
SelfMod:ld      0(1)                    ; naughty naughty...
        st      2(2)                    ; show dice 1
        ld      80h(1)                  ; get dice 2 pattern
        st      5(2)                    ; show dice 2
        dly     64                      ; added by PSR,reduces flicker
        ldi     0
        st      5(2)
        ild     2(2)                    ; go pressed ?
        jnz     Repeat                  ; if so, another round !
        jmp     Show                    ; show again

        .end

